/* ide-vala-diagnostics.c generated by valac 0.44.7, the Vala compiler
 * generated from ide-vala-diagnostics.vala, do not modify */

/* ide-vala-diagnostics.vala
 *
 * Copyright 2015 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "libide-code.h"
#include "libide-core.h"
#include "libide-debugger.h"
#include "libide-editor.h"
#include "libide-foundry.h"
#include "libide-greeter.h"
#include "libide-gui.h"
#include "libide-io.h"
#include "libide-lsp.h"
#include "libide-plugins.h"
#include "libide-projects.h"
#include "libide-search.h"
#include "libide-sourceview.h"
#include "libide-terminal.h"
#include "libide-threading.h"
#include "libide-tree.h"
#include "libide-vcs.h"

#define IDE_TYPE_VALA_DIAGNOSTICS (ide_vala_diagnostics_get_type ())
#define IDE_VALA_DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnostics))
#define IDE_VALA_DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnosticsClass))
#define IDE_IS_VALA_DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_DIAGNOSTICS))
#define IDE_IS_VALA_DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_DIAGNOSTICS))
#define IDE_VALA_DIAGNOSTICS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnosticsClass))

typedef struct _IdeValaDiagnostics IdeValaDiagnostics;
typedef struct _IdeValaDiagnosticsClass IdeValaDiagnosticsClass;
typedef struct _IdeValaDiagnosticsPrivate IdeValaDiagnosticsPrivate;

#define IDE_TYPE_VALA_SOURCE_FILE (ide_vala_source_file_get_type ())
#define IDE_VALA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_SOURCE_FILE, IdeValaSourceFile))
#define IDE_VALA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_SOURCE_FILE, IdeValaSourceFileClass))
#define IDE_IS_VALA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_SOURCE_FILE))
#define IDE_IS_VALA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_SOURCE_FILE))
#define IDE_VALA_SOURCE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_SOURCE_FILE, IdeValaSourceFileClass))

typedef struct _IdeValaSourceFile IdeValaSourceFile;
typedef struct _IdeValaSourceFileClass IdeValaSourceFileClass;
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

struct _IdeValaDiagnostics {
	ValaReport parent_instance;
	IdeValaDiagnosticsPrivate * priv;
};

struct _IdeValaDiagnosticsClass {
	ValaReportClass parent_class;
};

static gpointer ide_vala_diagnostics_parent_class = NULL;
static GType ide_vala_diagnostics_type_id = 0;

GType ide_vala_diagnostics_register_type (GTypeModule * module);
GType ide_vala_diagnostics_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IdeValaDiagnostics, vala_report_unref)
void ide_vala_diagnostics_clear (IdeValaDiagnostics* self);
static void ide_vala_diagnostics_add (IdeValaDiagnostics* self,
                               ValaSourceReference* source_reference,
                               const gchar* message,
                               IdeDiagnosticSeverity severity);
GType ide_vala_source_file_register_type (GTypeModule * module);
GType ide_vala_source_file_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IdeValaSourceFile, vala_source_file_unref)
void ide_vala_source_file_report (IdeValaSourceFile* self,
                                  ValaSourceReference* source_reference,
                                  const gchar* message,
                                  IdeDiagnosticSeverity severity);
static void ide_vala_diagnostics_real_note (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_depr (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_warn (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_err (ValaReport* base,
                                    ValaSourceReference* source_reference,
                                    const gchar* message);
IdeValaDiagnostics* ide_vala_diagnostics_new (void);
IdeValaDiagnostics* ide_vala_diagnostics_construct (GType object_type);

void
ide_vala_diagnostics_clear (IdeValaDiagnostics* self)
{
	g_return_if_fail (self != NULL);
	((ValaReport*) self)->errors = 0;
	((ValaReport*) self)->warnings = 0;
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static void
ide_vala_diagnostics_add (IdeValaDiagnostics* self,
                          ValaSourceReference* source_reference,
                          const gchar* message,
                          IdeDiagnosticSeverity severity)
{
	ValaSourceFile* _tmp0_;
	ValaSourceFile* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	if (source_reference == NULL) {
		return;
	}
	_tmp0_ = vala_source_reference_get_file (source_reference);
	_tmp1_ = _tmp0_;
	if (IDE_IS_VALA_SOURCE_FILE (_tmp1_)) {
		IdeValaSourceFile* file = NULL;
		ValaSourceFile* _tmp2_;
		ValaSourceFile* _tmp3_;
		IdeValaSourceFile* _tmp4_;
		IdeValaSourceFile* _tmp5_;
		_tmp2_ = vala_source_reference_get_file (source_reference);
		_tmp3_ = _tmp2_;
		_tmp4_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, IDE_TYPE_VALA_SOURCE_FILE, IdeValaSourceFile));
		file = _tmp4_;
		_tmp5_ = file;
		ide_vala_source_file_report (_tmp5_, source_reference, message, severity);
		_vala_source_file_unref0 (file);
	}
}

static void
ide_vala_diagnostics_real_note (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_NOTE);
}

static void
ide_vala_diagnostics_real_depr (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_DEPRECATED);
	((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
}

static void
ide_vala_diagnostics_real_warn (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_WARNING);
	((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
}

static void
ide_vala_diagnostics_real_err (ValaReport* base,
                               ValaSourceReference* source_reference,
                               const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_ERROR);
	((ValaReport*) self)->errors = ((ValaReport*) self)->errors + 1;
}

IdeValaDiagnostics*
ide_vala_diagnostics_construct (GType object_type)
{
	IdeValaDiagnostics* self = NULL;
	self = (IdeValaDiagnostics*) vala_report_construct (object_type);
	return self;
}

IdeValaDiagnostics*
ide_vala_diagnostics_new (void)
{
	return ide_vala_diagnostics_construct (IDE_TYPE_VALA_DIAGNOSTICS);
}

static void
ide_vala_diagnostics_class_init (IdeValaDiagnosticsClass * klass,
                                 gpointer klass_data)
{
	ide_vala_diagnostics_parent_class = g_type_class_peek_parent (klass);
	((ValaReportClass *) klass)->note = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_note;
	((ValaReportClass *) klass)->depr = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_depr;
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_warn;
	((ValaReportClass *) klass)->err = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_err;
}

static void
ide_vala_diagnostics_instance_init (IdeValaDiagnostics * self,
                                    gpointer klass)
{
}

GType
ide_vala_diagnostics_get_type (void)
{
	return ide_vala_diagnostics_type_id;
}

GType
ide_vala_diagnostics_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IdeValaDiagnosticsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ide_vala_diagnostics_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdeValaDiagnostics), 0, (GInstanceInitFunc) ide_vala_diagnostics_instance_init, NULL };
	ide_vala_diagnostics_type_id = g_type_module_register_type (module, VALA_TYPE_REPORT, "IdeValaDiagnostics", &g_define_type_info, 0);
	return ide_vala_diagnostics_type_id;
}

